package MySubs;
use strict;
sub SaveAsPerlCode{ 
    my %P=@_;
    my $Filehandle=$P{'FILEHANDLE'} or die;
    my $ThisIndentString;my $NextIndentString;
    # If Indent is defined, use it and append ' ' for the next level.
    # If not, give UNDEF as argument.
    my $Indent=$P{'INDENT'}; if (!defined($Indent)){
	$ThisIndentString='';
    } else {
	$ThisIndentString=$Indent;
	$NextIndentString=$Indent.' ';
    };
    my $Structure=$P{'STRUCTURE'};
    if (!defined $Structure){print $Filehandle 'undef'; return;}
    my $Type; my $Class;
    my $Ref=ref($Structure);
    if ($Ref eq 'HASH'){$Type='HASH';}
    elsif ($Ref eq 'ARRAY'){$Type='ARRAY';}
    elsif ($Ref ne ''){$Type='OBJECT';$Class=$Ref;;}
    else {$Type='SCALAR'};
    if ($Type eq 'HASH' || $Type eq 'OBJECT'){
	my @Keylist=keys(%{$Structure});
	my @ValueList=values(%{$Structure});
	# New indent for each line
	if (defined($Indent)){print $Filehandle "\n".$ThisIndentString;}
	# if object, wrap in 'bless'
	if ($Type eq 'OBJECT'){
	    print $Filehandle "bless(";
	};  
	print $Filehandle '{';
	my $i;for($i=0;$i<=$#Keylist;$i++){   
	    # New indent for each object
	    if (defined($Indent)){print $Filehandle "\n".$ThisIndentString;}
	    print $Filehandle "'".$Keylist[$i]."'=>";
	    &SaveAsPerlCode('FILEHANDLE' => $Filehandle,'INDENT'=>$NextIndentString,'STRUCTURE'=>$ValueList[$i]);
	    if ($i < $#Keylist){print $Filehandle ',';};
	}; # for i
	print $Filehandle '}';
	if ($Type eq 'OBJECT'){
	    print $Filehandle ",'$Class')";
	};  
    } elsif ($Type eq 'ARRAY'){
    	print $Filehandle '[';
	my @Array=@{$Structure};
	my $i;for($i=0;$i<=$#Array;$i++){   
	    if (defined($Indent)){print $Filehandle "\n".$ThisIndentString;}
	    &SaveAsPerlCode('FILEHANDLE' => $Filehandle,'INDENT'=>$NextIndentString,'STRUCTURE'=>$Array[$i]);
	    if ($i<$#Array){print $Filehandle ',';};
	};
    	print $Filehandle ']';
    } elsif ($Type eq 'SCALAR'){
	# Write the ASCII string.
	# As long as it does not contain the ' character, everything is fine.
	# If it does, then we have to use another delimiter.
	if ($Structure!~/\'/){
	    print $Filehandle "'$Structure'";
	} else {
	    # Now we use the q//-construct. We have to find a limiting character, though.
	    my @DelimList=("!","@","\$","\%","\&","\/","\=","\`","\#","\^","\~","panic");
	    my $D;
	    DelimLoop:foreach $D(@DelimList){
		die "too many strange characters in $Structure. Not saved!" if ($D eq 'panic');
		if ($Structure!~/$D/){
		    print $Filehandle "q$D$Structure$D";
		    last DelimLoop;
		};
	    }; # foreach Delimiter
	}; # if string contains ' character
    } else {die;}
};

sub Min{
    my @Elems=@_;
    my $Minimum=pop(@Elems);
    my $Elem;
    foreach $Elem(@Elems){
	if ($Elem<$Minimum){
	    $Minimum=$Elem;
	};
    };
    return $Minimum;
};

sub Max{
    my @Elems=@_;
    my $Maximum=pop(@Elems);
    my $Elem;
    foreach $Elem(@Elems){
	if ($Elem>$Maximum){
	    $Maximum=$Elem;
	};
    };
    return $Maximum;
};

sub UndefAlt{
    my $Var1=shift; my $Var2=shift;
    if (defined $Var1){return $Var1;}; return $Var2;
};
sub SplitAbsolutePath{
    my $Line=shift or die;
    if ($Line=~/^(.*)\/(.*?)$/){
	return {'PATH' => $1,'FILE' => $2};
    };
    return {'PATH' => '','FILE' => $Line};
}; 
sub QueryEPSGeom{
    my $EPSFilename=shift or die;
    open EPSFile,"<$EPSFilename" or return undef;
    my $InLine; 
    my ($X1,$Y1,$X2,$Y2);
  BBLoop:while (defined($InLine=<EPSFile>)){
      if ($InLine=~/^\%\%BoundingBox\:\s*(\-*\d+)\s+(\-*\d+)\s+(\-*\d+)\s+(\-*\d+)\s*$/){
	  $X1=$1;$Y1=$2;
	  $X2=$3;$Y2=$4;
	  last BBLoop;
      };
  };
    close EPSFile;
    if(defined $Y2){
	return {'X1'=>$X1,'Y1'=>$Y1,'X2'=>$X2,'Y2'=>$Y2};
    } else {  
#	die "%%BoundingBox not found! $EPSFilename is no EPS file? " ;
	return undef;
    }; 
};
sub PictureTotalName{
    my %P=@_;
    my $ID=$P{'ID'}; die unless defined $ID;
    my $Identifier=$P{'IDENTIFIER'} or die;
    return $Identifier.$ID;
};
sub DoubleQuoteForShell{
    my $Arg=shift;
    if (defined $Arg){
	$Arg=~s/\"/\\\\\\\"/g; # this deserves a comment: replace " with \\\\\"
    };
    return $Arg;
}; 
1;










