package PopupWindow;
use Tk;
use strict;

use Tk::NoteBook;
use Tk::Balloon;
my @PL=qw(-side top -anchor w);
my @NBPack=(-expand => "yes",
	    -fill => "both",
	    -padx => 5, -pady => 5,
	    -side => "top");
my @LBPack=qw(-side top -anchor w -fill x);
sub New{
    my $proto=shift;
    my $class=ref($proto) || $proto;
    my %P=@_;
    my $self={};
    bless($self,$class);
    my $MainWin=$P{MAINWIN} or die;
    $self->{WIN}=$MainWin->Toplevel;
    $self->{WIN}->resizable(0,0);
    $self->{WIN}->transient($MainWin);   
    $self->{TEXTVARS}=[];
    my @Data=@{$P{DATA}} or die;
    my $Type; foreach $Type(qw(THING LINE COMMAND)){
	$self->{"WIDGETS_$Type"}=[];
	$self->{"FLAGS_$Type"}=[]; if ($P{"FLAGS_$Type"}){$self->{"FLAGS_$Type"}=$P{"FLAGS_$Type"}}; 
  };
    if ($::BalloonHelp){
	$self->{BALLOONWIDGET}=$self->{WIN}->Balloon or die;	
    };
    my $Dataline; foreach $Dataline(@Data){
	$self->ProcessDataline('PARENT' => $self->{WIN},'DATA' => $Dataline);
    };
    $self->{WIN}->waitVisibility;

    $self->{DEFAULT_REACTION}=sub{$self->Update;};
    my $Raise; foreach $Raise('RAISE_THING','RAISE_LINE','RAISE_COMMAND'){
	$self->{$Raise}=$P{$Raise} or die;
    };   
    $self->{WIN}->bind('<Control-space>',sub{$::UIManager->Eval_br;Tk->break;} );
    return $self;
};
sub ProcessDataline{
    my $self=shift or die;
    my %P=@_;
    my @W=@{$P{'DATA'}};
    my $Parent=$P{'PARENT'} or die;
    my $Keyword=$W[0] or die;
    my $Data=$W[1]; die $Keyword unless defined $Data;
    my $Args;	
#    if ($W[2]){
    $Args=$W[2]; die unless defined $Args;
	#};
    my %Args=%{$Args};
#    &D($Keyword);
    my @Packlist=@PL;
    my $NewWidget;	
    my $WidgetToEnableDisable; my $LabelToEnableDisable;
    
    # This funny looking piece of code executes the contents of $self->{'DEFAULT_REACTION'}, when the button
    # is clicked. 
    my $SelType=$self->{SELTYPE};

    my $ToDo; 
    if($Args{-command}){
	$ToDo=$Args{-command};
	delete $Args{-command};
    } else {
	$ToDo=sub{my $v=$self->{'DEFAULT_REACTION'};&$v;};
    };
    my $SetCode;
    if ($Args->{SETCODE}){
	$SetCode=$Args->{SETCODE};
	delete $Args{SETCODE};
    };
    my $UpdateCode;
    if ($Args->{UPDATECODE}){
	$UpdateCode=$Args->{UPDATECODE};
	delete $Args{UPDATECODE};
    };
    my $ClickCode;
    if ($Args->{CLICKCODE}){
	$ClickCode=$Args->{CLICKCODE};
	delete $Args{CLICKCODE};
    };
    my $BalloonMsg='';
    if ($Args->{-balloon}){
	$BalloonMsg=$Args->{-balloon};
	delete $Args{-balloon};
    };
    if($Keyword eq 'WINPROP'){
	my $Title=$Args->{'TITLE'} or die;
	$self->{WIN}->title($Title);
    } elsif($Keyword eq 'SET_SELTYPE'){
	$self->{SELTYPE}=$Args->{'SELTYPE'} or die;
    } else {
	if ($Keyword eq 'NOTEBOOK'){
	    $NewWidget = $Parent->NoteBook(-ipadx => 6, -ipady => 6);
	    @Packlist=@NBPack;
	    if (!$self->{TOPLEVEL_NOTEBOOK}){
		$self->{TOPLEVEL_NOTEBOOK}=$NewWidget;
	    };
	} elsif ($Keyword eq 'PAGE'){
	    my $Name=$Args{-label} or die;
	    $NewWidget=$Parent->add($Name, -label => $Name, -underline => 0);
	} elsif ($Keyword eq 'LABEL'){
	    my $Text=$Args{-text} or die;
	    $NewWidget=$Parent->Label(-text => $Text )->pack(@PL);
	} elsif ($Keyword eq 'CB'){
	    $NewWidget=$Parent->Checkbutton(%Args,-command => $ToDo)->pack(@PL);
	    push @{$self->{"WIDGETS_$SelType"}},$NewWidget;
	} elsif ($Keyword eq 'RB'){
	    $NewWidget=$Parent->Radiobutton(%Args,-command => $ToDo)->pack(@PL);
	    push @{$self->{"WIDGETS_$SelType"}},$NewWidget;
	} elsif ($Keyword eq 'E'){ 
	    # Don't use Labentry. It does not work on all machines.
	    my $Text=$Args{-text} or die;
	    my $Var=$Args{-variable} or die;
	    $NewWidget=$Parent->Frame();
	    $LabelToEnableDisable=$NewWidget->Label(-text => $Text,-width => 12)->pack(-side => 'left',-fill => 'x',-expand => 1);
	    my $a=$NewWidget->Entry(-textvariable => $Var,-font => 'ENTRYFONT',-width => 28)->pack(-side => 'left',-fill => 'x',-expand => 1);	    	    
	    push @{$self->{"WIDGETS_$SelType"}},$a;	
	    $a->bind('<Return>',$ToDo);
	    push @{$self->{TEXTVARS}},$Var;
	    $WidgetToEnableDisable=$a; #not the frame, but the entry
	} elsif ($Keyword eq 'LB'){ 
	    $NewWidget=$Parent->Scrolled("Listbox",-scrollbars => "se", -selectmode => "single",-height=>6);
	    @Packlist=@LBPack;
	    if ($ClickCode){
		$NewWidget->bind('<Button-1>',sub {&$ClickCode(WIDGET => $NewWidget);$self->Update;});
	    };
	} elsif ($Keyword eq 'OM'){ # Optionmenu
	    $NewWidget=$Parent->Optionmenu(%Args,-command => $ToDo)->pack(@PL);
	    push @{$self->{"WIDGETS_$SelType"}},$NewWidget;
	} else {die join("",@{$Keyword})." ";}
	my $Dataline; foreach $Dataline(@{$Data}){
	    $self->ProcessDataline(PARENT => $NewWidget,DATA => $Dataline);
	};
	if ($Keyword ne 'PAGE'){
	    $NewWidget->pack(@Packlist);
	};   
	if ($::BalloonHelp){
	    $self->{BALLOONWIDGET}->attach($NewWidget,-msg => $BalloonMsg);
	};
    };

    # The Setcode / UpdateCode operates on the widget.
    # In case of 'Entry', this is actually a frame (which cannot be enabled / disabled).
    # Therefore, in this case, the real entry line is picked out.
    if (!$WidgetToEnableDisable){
	$WidgetToEnableDisable=$NewWidget;
    };
    if ($SetCode){
	push @{$self->{SETCODE}},sub{&$SetCode(WIDGET => $WidgetToEnableDisable,CONTEXT => $self->{CONTEXT}, LABEL => $LabelToEnableDisable)};
    }; 
    if ($UpdateCode){
	push @{$self->{UPDATECODE}},sub{&$UpdateCode(WIDGET => $WidgetToEnableDisable,CONTEXT => $self->{CONTEXT},LABEL => $LabelToEnableDisable)};
    };

    # better late than never - read again, because it may have changed
#    $SelType=$self->{SELTYPE};
#    die unless $SelType eq 'THING'||$SelType eq 'LINE'||$SelType eq 'COMMAND'; 
};
sub SetContext{
    my $self=shift or die;
    die unless $self->AreYouOK;
    my %P=@_;
    $self->{CONTEXT}=\%P;
    my $CT=$self->QueryContextType or die;
    $self->{CONTEXT}->{CONTEXTTYPE}=$CT;

    $self->InitializeWidgets;

    # raise the appropriate notebook page
    my $RaisePage=$self->{"RAISE_$CT"};
    if ($RaisePage && $self->{TOPLEVEL_NOTEBOOK}){
	$self->{TOPLEVEL_NOTEBOOK}->raise($RaisePage);
    };
    
};  
sub InitializeWidgets{
    my $self=shift or die;
    die unless $self->AreYouOK;
    my %Context=%{$self->{CONTEXT}};
    
    # turn on / off widgets
    my $CT=$self->{CONTEXT}->{CONTEXTTYPE};
    my $Type; foreach $Type(qw(THING LINE COMMAND)){
	my $NewState='disabled';
	if (($CT eq 'THING' && $Type eq 'THING')
	    || ($CT eq 'LINE' && ($Type eq 'THING' || $Type eq 'LINE'  ))
	    || ($CT eq 'COMMAND')){
	    $NewState='normal';
	};
	my $Widget; foreach $Widget(@{$self->{"WIDGETS_$Type"}}){
	    $Widget->configure(-state => $NewState);
	};
    };

    if (!$self->{CONTEXT}->{EDITMODE}){return;} # nothing in editor - nothing to do
    my $Thing=$Context{THING};
    # Set new values from thing
    if ($Thing){
	my $Flag; 
	foreach $Flag(@{$self->{FLAGS_THING}}){
	    my $NewFlag=$Thing->QueryFlag(FLAGMODE => 'THING', FLAG => $Flag);
	    $self->{FLAGS}->{$Flag}=$NewFlag; die unless defined $NewFlag;
	};
	my $Index=$Context{INDEX};
	if (defined $Index){
	    foreach $Flag(@{$self->{FLAGS_LINE}}){
		my $NewFlag=$Thing->QueryFlag(FLAGMODE =>'LINE', FLAG => $Flag, INDEX => $Index);
		$self->{FLAGS}->{$Flag}=$NewFlag; die unless defined $NewFlag;
	    };
	    my $Path=$Context{PATH};
	    if (defined $Path){
		foreach $Flag(@{$self->{FLAGS_COMMAND}}){
		    my $NewFlag=$Thing->QueryFlag(FLAGMODE => 'COMMAND', FLAG => $Flag, INDEX => $Index, PATH => $Path);
		    $self->{FLAGS}->{$Flag}=$NewFlag; die unless defined $NewFlag;
		};
	    }; # if path defined
	}; # if index defined
    };

    # run the code to set special widgets (listboxes)
    my $Code; foreach $Code(@{$self->{SETCODE}}){
#	&$Code($self->{CONTEXT});
	&$Code;
    };	
};
sub AreYouOK{
    my $self=shift or die;
    # We don't even try to cover all the ways the user could possibly close the dialog. 
    # Instead, we check if the dialog widget is still existing before accepting any command (for example 'set context') from the outside.
    if (Exists($self->{WIN})){return 1;}; 
    return 0;
};
sub Update{
    my $self=shift or die;
    my %P=@_;
   
    if (!$self->{CONTEXT}->{EDITMODE}){return;} # nothing in editor - nothing to do

    # The number 0 is not a valid content of a flag: The flag gets deleted instead.
    # Therefore, replace '0' in all entries with '0 ', which is almost as good as '0', but TRUE...

    my $Var; foreach $Var(@{$self->{TEXTVARS}}){
	if (defined $$Var && $$Var eq '0'){$$Var='0.';} 
    };
    
    # run the code to update from special widgets (RefEntryline)
    my $Code; foreach $Code(@{$self->{UPDATECODE}}){
#	&$Code($self->{CONTEXT});
	&$Code;
    };
    
    my $Thing=$self->{CONTEXT}->{THING};
    # Set new values to thing
    if ($Thing){
	my $Flag; 
	foreach $Flag(@{$self->{FLAGS_THING}}){
	    my $New=$self->{FLAGS}->{$Flag}; die $Flag unless defined $New;
	    $Thing->SetFlag(FLAGMODE => 'THING', FLAG => $Flag, 'NEW' => $New);
	};
	my $Index=$self->{CONTEXT}->{INDEX};
	if (defined $Index){
	    foreach $Flag(@{$self->{FLAGS_LINE}}){
		my $New=$self->{FLAGS}->{$Flag}; die $Flag unless defined $New;
		$Thing->SetFlag(FLAGMODE => 'LINE', FLAG => $Flag, INDEX => $Index, 'NEW' => $New);
	    };
	    my $Path=$self->{CONTEXT}->{PATH};
	    if (defined $Path){
#		print "Current context: Index $Index Path $Path.\n";
		foreach $Flag(@{$self->{FLAGS_COMMAND}}){
		    my $New=$self->{FLAGS}->{$Flag}; die $Flag unless defined $New;
		    $Thing->SetFlag(FLAGMODE => 'COMMAND', FLAG => $Flag, INDEX => $Index, PATH => $Path, 'NEW' => $New);
		};
	    };
	};
    }; 

    $::ThingManager->MakeEvaldirtyIfNeeded;
    $::ThingManager->Redraw('ALL' => 1);
    $::UIManager->DrawCursor;
    $self->InitializeWidgets; 

    $::MainDirty=1;
};
sub QueryContextType{
    my $self=shift or die;
    if (!$self->{'CONTEXT'}){return 'NONE'};
    if (!($self->{CONTEXT}->{EDITMODE})){return 'NONE'};
    if (!$self->{'CONTEXT'}->{'THING'}){return 'NONE'};
    if (!defined $self->{'CONTEXT'}->{'INDEX'}){return 'THING'};
    if (!defined ($self->{'CONTEXT'}->{'PATH'})){return 'LINE'};
    if ($self->{CONTEXT}->{EDITMODE} eq 'RESULT'){
	return 'LINE';
    };
    return 'COMMAND';
};
sub QueryContext{
    my $self=shift or die;
    return $self->{'CONTEXT'};
};
sub Destroy{ 
    # bye bye
    my $self=shift or die;
    $self->{WIN}->destroy;
};
sub D{
    my $Prt=shift;
    print $Prt."\n";
};
1;
