package UIManager;
use strict;
use Symaxx2::PopupManager;
use Tk;
use Tk::Balloon;

sub New{
    my $self={}; bless $self; 
    my %P=@_;
    my $M=$self->New_CreateMainWin;
    if ($::BalloonHelp){
	$self->{BALLOONWIDGET}=$::MainWin->Balloon or die;	
    };
    $self->New_CreateMenuAndButtons;
    $self->New_CreateCanvas;
    $self->New_CreateFonts;
    $self->New_CreateInputLine;
    $self->New_SetDefaults;  

    return $self;	  
};
sub New_CreateInputLine{
    my $self=shift or die;
    my $F1=$::MainWin->Frame()->pack(-side => 'top', -fill => 'both');;
    $F1->Label(-text => 'Cmd',-width=>5)->pack(-side => 'left');
    
    $self->{'INPUTLINEWIDGET'}=$F1->Scrolled
	('Text',
	 -font => 'ENTRYFONT',
	 -relief => 'sunken', -borderwidth =>2, 
	 -height => 4, -scrollbars => 'e')->pack(-side => 'left',-fill => 'x',-expand => 1);	
    $self->{'INPUTLINEWIDGET'}->configure(-state => 'disabled');

    my $InLine=$self->{'INPUTLINEWIDGET'}->Subwidget('text');
    # When the user presses for example return, this will be processed by default by the widget
    # at the lower end of the tree (this may be the Text widget - it inserts a carriage return).
    # In this application, there is no need to insert returns - it runs a command instead.
    # Therefore the reception chain has to be rearranged. That's the bindtags command.
    
#    $InLine->bindtags([$InLine->toplevel,,$InLine,ref($InLine),'all']);
    $InLine->bindtags([$InLine->toplevel,$InLine,ref($InLine),,'all']);
    $self->ClearInputLine;
    $self->{'INPUTLINEWIDGET'}->bind('<Return>',sub{$self->ReturnInEntryLine_br;Tk->break;} );  
    $self->{'INPUTLINEWIDGET'}->bind('<Shift-Return>',sub{$self->ReturnInEntryLine_br;Tk->break;} );
    $self->{'INPUTLINEWIDGET'}->bind('<Alt-r>',sub{$self->InsertREFInEntryLine; Tk->break;}); 

    # ##################
#    $self->{'INPUTLINEWIDGET'}->bind('<Alt-u>',sub{print $self->{'INPUTLINEWIDGET'}->tagRanges('sel');Tk->break;} );
    $self->{'INPUTLINEWIDGET'}->bind('<Alt-u>',sub{print $self->{'INPUTLINEWIDGET'}->index('insert');Tk->break;} );
    # ##################

    $self->{'INPUTLINEWIDGET'}->bind('<Alt-p>',sub{$self->{'INPUTLINEWIDGET'}->insert('insert',"%pi");Tk->break;} );
    $self->{'INPUTLINEWIDGET'}->bind('<Alt-i>',sub{$self->{'INPUTLINEWIDGET'}->insert('insert',"%I");Tk->break;} );
    
    my $F2=$::MainWin->Frame()->pack(-side => 'top', -fill => 'both');
    $F2->Label(-text => 'Doc',-width=>5)->pack(-side => 'left');
    my $DocLineWidget=$F2->Entry(-textvariable => \ ($self->{'DOCLINE'}),
				 -font => 'ENTRYFONT')
	->pack(-side => 'bottom',-fill => 'x',-expand => 1);
    $DocLineWidget->bind('<Return>',sub{$self->ReturnInDocLine_br});
    $DocLineWidget->bind('<Control-Return>',sub{$DocLineWidget->insert('insert',"\n");}); 
    $self->{'DOCLINEWIDGET'}=$DocLineWidget;	
    $self->{'DOCLINEWIDGET'}->configure(-state => 'disabled');

    if ($::BalloonHelp){
	$self->{BALLOONWIDGET}->attach($self->{INPUTLINEWIDGET},-msg => 
"Create a new expression with the middle mouse button.
Click on the contents (1).
Then edit them in this field and press return.
To evaluate, press the #EVAL#-Button.");	
	$self->{BALLOONWIDGET}->attach($self->{DOCLINEWIDGET},-msg => 
"Enter documentation here, which will be attached to 
the selected object.");	
    };

};
sub New_CreateMenuAndButtons{
    my $self=shift or die;
    my @MenuData=
	({M=>'File',C=>'New',        X=>sub{$self->New_br;Tk->break},               K=>'Control-N'},
	 {M=>'File',C=>'Load',       X=>sub{$self->Load_br(INITIALDIR=>$::WorkDir);Tk->break},              K=>'Control-l'},
	 {M=>'File',C=>'Open demos',       X=>sub{$self->Load_br(INITIALDIR => $::CodeDir."/Demo");Tk->break},K => ''},
	 {M=>'File',C=>'Save',       X=>sub{$self->Save_br('SAVE'=>1);Tk->break},   K=>'Control-s'},
	 {M=>'File',C=>'Save as',    X=>sub{$self->Save_br('SAVEAS'=>1);Tk->break}, K=>'Control-S'},
	 {M=>'File',C=>'Print portrait',      X=>sub{$self->Print_br('MODE' => 'PORTRAIT');Tk->break},             K=>'Control-p'},
	 {M=>'File',C=>'Print Landscape',      X=>sub{$self->Print_br('MODE' => 'LANDSCAPE');Tk->break},             K=>''},
	 {M=>'File',C=>'Quit',       X=>sub{$self->Quit_br;Tk->break},              K=>'Control-q'},
	 {M=>'Edit',C=>'New Exp',    X=>sub{$self->NewThing_br;Tk->break},            K=>'Control-n'},
	 {M=>'Edit',C=>'Create from input'      ,X=>sub{$self->CreateFromInput_br;Tk->break},           K=>'Control-r'},
	 {M=>'Edit',C=>'Extract from result'      ,X=>sub{$self->ExtractFromResult_br;Tk->break},           K=>'Control-R'},
	 {M=>'Edit',C=>'Delete'      ,X=>sub{$self->Delete_br;Tk->break},           K=>'Control-Delete'},
	 {M=>'Edit',C=>'Eval'        ,X=>sub{$self->Eval_br;Tk->break},             K=>'Control-space'},
	 {M=>'Edit',C=>'New command'   ,X=>sub{$self->NewModifier_br;Tk->break},      K=>'Alt-n'},
	 {M=>'View',C=>'Interface',  X=>sub{$self->InterfacePage_br;Tk->break},     K=>'Control-I'},
	 {M=>'View',C=>'Inspect',    X=>sub{$self->Inspect_br;Tk->break},           K=>'Control-i'},
	 {M=>'Tools',C=>'Instant solve',    X=>sub{$self->InstantSolve_br},           K=>'F10'},
	 {M=>'Features',CB=>'Use units',    X=>sub{$::ThingManager->InvalidateAll;$::PopupManager->ReinitAll},  V=>\ $::MaximaUseUnits}, 
	 {M=>'Features',CB=>'Use Selection',    X=>sub{$::ThingManager->InvalidateAll;$::PopupManager->ReinitAll},  V=>\ $::MaximaUseSelection},	
	 {M=>'Features',CB=>'Use Gnuplot',    X=>sub{$::ThingManager->InvalidateAll;$::PopupManager->ReinitAll},  V=>\ $::MaximaUseGnuplot},	 
	 {M=>'Features',CB=>'Use Format',    X=>sub{$::ThingManager->InvalidateAll;$::PopupManager->ReinitAll},  V=>\ $::MaximaUseFormat},
	 {M=>'Features',CB=>'Use Numerical',    X=>sub{$::ThingManager->InvalidateAll;$::PopupManager->ReinitAll},  V=>\ $::MaximaUseNumerical},
#	 {M=>'Tests(debug)',C=>'rtest1.mac',     X=>sub{$self->SelfTest_br('rtest1.mac');Tk->break}, K=>''}, 
#	 {M=>'Tests(debug)',C=>'rtest2.mac',     X=>sub{$self->SelfTest_br('rtest2.mac');Tk->break}, K=>''}, 
#	 {M=>'Tests(debug)',C=>'rtest3.mac',     X=>sub{$self->SelfTest_br('rtest3.mac');Tk->break}, K=>''}, 
#	 {M=>'Tests(debug)',C=>'rtest4.mac',     X=>sub{$self->SelfTest_br('rtest4.mac');Tk->break}, K=>''}, 
#	 {M=>'Tests(debug)',C=>'rtest5.mac',     X=>sub{$self->SelfTest_br('rtest5.mac');Tk->break}, K=>''}, 
#	 {M=>'Tests(debug)',C=>'rtest6a.mac',     X=>sub{$self->SelfTest_br('rtest6a.mac');Tk->break}, K=>''}, 
#	 {M=>'Tests(debug)',C=>'rtest6b.mac',     X=>sub{$self->SelfTest_br('rtest6b.mac');Tk->break}, K=>''}, 
	 {M=>'Help',C=>'Symaxx Manual',     X=>sub{$self->Manual_br('SYMAXXMAN');Tk->break},            K=>'F1'},   
	 {M=>'Help',C=>'Maxima Primer', X=>sub{$self->Manual_br('MAXIMAPRIMER');Tk->break},  K=>'Shift-F1'},   
	 {M=>'Help',C=>'Maxima Manual', X=>sub{$self->Manual_br('MAXIMAMAN');Tk->break},     K=>'F2'},   
	 {M=>'Help',C=>'Maxima Index', X=>sub{$self->Manual_br('MAXIMAINDEX');Tk->break},  K=>'Shift-F2'}, 
	 {M=>'Help',C=>'FORMAT package doc',         X=>sub{$self->Manual_br('FORMAT');Tk->break}},    
	 {M=>'Help',C=>'About',         X=>sub{$self->About_br;Tk->break}}   
	 ); # MenuData
  
    my $BF=$::MainWin->Frame(-relief => 'ridge',-borderwidth => 2)->pack(-side => 'top',-fill => 'x');
    my $LastMenu='';
    my $Buttonwidget;
    my $MenuItem; foreach $MenuItem(@MenuData){
	my $Menu=$MenuItem->{M};
	my $Command=$MenuItem->{C};
	my $CheckButton=$MenuItem->{CB};
	my $Exec=$MenuItem->{X} or die;
	my $Key=$MenuItem->{K};if (!defined $Key){$Key='';}
	my $Var=$MenuItem->{V};
	if ($Menu){
	    if ($LastMenu ne $Menu || !$Buttonwidget){
		$Buttonwidget=$BF->Menubutton(-text => $Menu)->pack(-side => 'left');
		$LastMenu=$Menu;
	    };
	    if ($Command){
		$Buttonwidget->command(-label => $Command,-command => $Exec,-accelerator => $Key);
	    } elsif ($CheckButton){
		$Buttonwidget->checkbutton(-label => $CheckButton,-variable => $Var,-command => $Exec,-accelerator => $Key);
	    };
	};
	if ($Key){$::MainWin->bind("<$Key>" ,$Exec);};
    }; # foreach MenuItem

    $self->{EVALBUTTON}=$BF->Button(-text=>'#Eval#',-command => sub{$self->Eval_br;},-width=>8)->pack(-side => 'right'); 
    $self->{DISPBUTTON}=$BF->Button(-text=>'Interface',-command => sub{$self->InterfacePage_br;},-width=>8)->pack(-side => 'right');
    
    $self->{INSPECTBUTTON}=$BF->Button(-text=>'Inspect',-command => sub{$self->Inspect_br},-width=>8)->pack(-side => 'right');
    $self->{BUTTONORIGCOLOR}=($self->{INSPECTBUTTON}->configure(-background))[3]; 
    $self->{PALETTEBUTTON}=$BF->Button(-text=>'Palette',-command => sub{$self->Palette_br},-width=>8)->pack(-side => 'right');
    if ($::BalloonHelp){
	$self->{BALLOONWIDGET}->attach($self->{EVALBUTTON},-msg => 
"RUN MAXIMA:
Evaluates all items, 
which are not up-to-date (marked red).
You can also press CTRL-Space.");	
	$self->{BALLOONWIDGET}->attach($self->{DISPBUTTON},-msg => 
"With this button you can make
all items disappear, which do not have
the 'Interface'-flag set.
Good for making all the clutter between 
'input' and 'output' of a lengthy 
calculation disappear...");
	$self->{BALLOONWIDGET}->attach($self->{INSPECTBUTTON},-msg => 
"Inspect the output from the last Maxima-session.
Here, all error messages can be found.");	
	$self->{BALLOONWIDGET}->attach($self->{PALETTEBUTTON},-msg => 
"Pops up a palette with some frequently-
needed commands.");
    }; #if balloonhelp
    
    if (defined $::GOCount){
	$BF->Label(-text => "GrO")->pack(-side => 'left'); 
	$BF->Label(-textvariable => \ $::GOCount)->pack(-side => 'left');
    };
    if (defined $::LispListCount){
	$BF->Label(-text => "LispO")->pack(-side => 'left'); 
	$BF->Label(-textvariable => \ $::LispListCount)->pack(-side => 'left');
    };
    if (defined $::INPARTPath){
	$BF->Label(-textvariable => \ $::INPARTPath)->pack(-side => 'left');
    };
    $::INPARTPath='';
	
    $::GOCount=0;
    $::LispListCount=0;
};
sub New_CreateMainWin{
    my $self=shift or die;
    $::MainWin=MainWindow->new;	
    $::MainWin->protocol('WM_DELETE_WINDOW' => sub {&Quit_br;}); # catch window close command 
    if ($::DefaultGeometry){
	$::MainWin->geometry($::DefaultGeometry);
    };
    # Smaller does not make sense, because input lines disappear
    $::MainWin->minsize(200,150);

    return $::MainWin;
};
sub New_CreateCanvas{
    my $self=shift or die;
    $self->{'CANVAS'} = $::MainWin->Scrolled("Canvas",-scrollbars => "se",-width => 100, -height=>100,-background=>$::MainWinBackground)->pack(-expand => 1, -fill => 'both');
    my $CC=$self->{'CANVAS'}->Subwidget("canvas");
    $CC->Tk::bind("<Button-1>",[\&MouseDown,$self,Tk::Ev('x'),Tk::Ev('y'),'leftdown']);
    $CC->Tk::bind("<Button-2>",[\&MouseDown,$self,Tk::Ev('x'),Tk::Ev('y'),'middledown']);
    $CC->Tk::bind("<Button-3>",[\&MouseDown,$self,Tk::Ev('x'),Tk::Ev('y'),'rightdown']);
    $CC->Tk::bind("<ButtonRelease-1>",[\&MouseDown,$self,Tk::Ev('x'),Tk::Ev('y'),'leftup']);
    $CC->Tk::bind("<Motion>",[\&MouseMove,$self,Tk::Ev('x'),Tk::Ev('y')]);
    $::GlobalCanvas=$CC;
};
sub New_CreateFonts{
    $::MainWin->fontCreate('ENTRYFONT',-family => 'times',-size => 12); # Create the font for the entry widgets
    $::UpperFontHeight=$::FontHeight/2+1;
    $::LowerFontHeight=$::FontHeight/2+1;
    
    $::GlobalCanvas->fontCreate('FRAGFONT',-family => 'times',-size => -$::FontHeight);
    my $Fontname; foreach $Fontname('HEADING3','HEADING2','HEADING1'){
	$::GlobalCanvas->fontCreate($Fontname,-family => 'times',-size => -$::FontHeight_{$Fontname});
	$::UpperFontHeight_{$Fontname}=$::FontHeight_{$Fontname}/2+1;
	$::LowerFontHeight_{$Fontname}=$::FontHeight_{$Fontname}/2+1;

	$::FontWrapColumns_{$Fontname}=32000; # turn off wrapping for all non-standard fonts.
    };
}; 
sub New_SetDefaults{
    my $self=shift or die;
    $self->{'DISPLAYPAGE'}='NORMAL';
    $self->{'PICLIST'}={};
    $self->{'LASTINSERTX'}=0;
    $self->{'LASTINSERTY'}=0;
};
    
sub MouseDown{
    my $Canvas=shift or die;
    my $self=shift or die;
    my $XP=shift; die unless defined $XP;
    my $YP=shift; die unless defined $YP;
    my $Action=shift or die;
    my $X=$Canvas->canvasx($XP);
    my $Y=$Canvas->canvasy($YP);
    delete $self->{'SCAN'};
    if ($Action =~/down$/){
	my $ClickInfo=$::ThingManager->QueryWhatsClicked('X'=>$X,'Y'=>$Y);
	my $Thing=$ClickInfo->{'THING'};
	if ($Action eq 'leftdown' || ($Action eq 'rightdown')){
	    $self->{'MOUSEDOWNX'}=$X;
	    $self->{'MOUSEDOWNY'}=$Y;
	    if ($Thing){
		$self->PutThingIntoEditor(%{$ClickInfo},'X' => $X,'Y' => $Y); # propagates THING
	    } else {
		$self->PutThingIntoEditor; 
		if ($Action eq 'leftdown'){
		    # Prepare 'scanning'
		    $self->{'SCAN'}=1;
		    $Canvas->scan('mark',$XP,$YP);
		}; # if left
	    }; # if Thing
	    if ($Action eq 'leftdown'){
		$self->{'THINGMAYBEMOVING'}=$Thing;
	    } else {
		delete $self->{'THINGMAYBEMOVING'}
	    };	    
	    
	}; # if left or right button down 
	if ($Action eq 'rightdown'){
	    # show popup window
	    $::PopupManager->Open(WHAT => 'THING_GLOBAL',%{$ClickInfo},EDITMODE => $self->QueryEditmode);
	} elsif ($Action eq 'leftdown'){
	    # if (not) right button down 
	} elsif ($Action eq 'middledown'){
	    if ($self->QueryThing){
		$self->NewModifier_br;
	    } else {
		$self->NewThing_br('X' => $X,'Y'=>$Y);
	    };
	};	
    } elsif ($Action =~/up$/){
	if ($Action eq 'leftup'){
	    if ($self->{'THINGMOVING'}){
		if ($self->QueryEditmode eq 'COMMAND' || $self->QueryEditmode eq 'RESULT'|| $self->QueryEditmode eq 'HEAD'|| $self->QueryEditmode eq 'HANDLE'){
		    $self->{'THINGMOVING'}->MoveTo('X'=>$X+$self->{'XOFFSET'},'Y'=>$Y+$self->{'YOFFSET'});
		    
		    # We keep track on where the thing, which was inserted last, is moved to.
		    # The next new object (Ctrl-N) will appear below.
		    if ($self->{'LASTINSERTTHING'} && ($self->{'THINGMOVING'} eq $self->{'LASTINSERTTHING'})){
			$self->{'LASTINSERTX'}=$X+$self->{'XOFFSET'};
			$self->{'LASTINSERTY'}=$Y+$self->{'YOFFSET'};    
		    };
		} elsif ($self->QueryEditmode eq 'MODIF'){
		    $self->{'THINGINEDITOR'}->MoveModifierRelative
			('INDEX' => $self->QueryIndex,
			 'PATH' => $self->QueryPath,
			 'TYPE' => $self->QueryEditmode,
			 'DX'=> $X-$self->{'MOUSEDOWNX'},
			 'DY',$Y-$self->{'MOUSEDOWNY'});
		};
		$self->Redraw('ALL'=>1);
		delete $self->{'THINGMOVING'};
		$::GlobalCanvas->delete("MOVE");
		$::MainDirty=1;
	    }; # if THINGMOVING
	    delete $self->{'MOUSEDOWNX'};
	    delete $self->{'MOUSEDOWNY'};
	};
	$::INPARTPath='';
    }; # if UP-action
};
sub MouseMove{
    my $Canvas=shift or die;
    my $self=shift or die;
    my $XP=shift; die unless defined $XP;
    my $YP=shift; die unless defined $YP;
    my $X=$Canvas->canvasx($XP);
    my $Y=$Canvas->canvasy($YP);
    $self->{'MOUSEX'}=$X;
    $self->{'MOUSEY'}=$Y;
    if ($self->{'MOUSEDOWNX'}){
	my $DragDist=($self->{'MOUSEDOWNX'}-$X)**2+($self->{'MOUSEDOWNY'}-$Y)**2;
	if ($DragDist>20){
	    my $Thing=$self->{'THINGMAYBEMOVING'};
	    if ($Thing){
		$self->{'THINGMOVING'}=$self->{'THINGMAYBEMOVING'};
		delete $self->{'THINGMAYBEMOVING'}
	    };
	};
    };
    if ($self->{'THINGMOVING'}){
	my $X1=$X+$self->{'XOFFSET'};
	my $Y1=$Y+$self->{'YOFFSET'}-$self->{'THINGUPPERHEIGHT'};
	my $X2=$X+$self->{'XOFFSET'}+$self->{'THINGWIDTH'};
	my $Y2=$Y+$self->{'YOFFSET'}+$self->{'THINGLOWERHEIGHT'};
	$::GlobalCanvas->delete("MOVE");
	$::GlobalCanvas->createRectangle($X1,$Y1,$X2,$Y2,-tags => 'MOVE'); 
    } else {
	if ($self->{'SCAN'}){
	    $Canvas->scan('dragto',$XP,$YP);
	};
    }
#    print "$X $Y \n";
};
    
sub ReturnInEntryLine_br{
    my $self=shift or die;
    my %P=@_;
    my $Thing=$self->{'THINGINEDITOR'};
    if ($Thing){
	my %Selection=('TYPE' => $self->QueryEditmode,
		       'INDEX' => $self->QueryIndex,
		       'PATH' => $self->QueryPath);
	
	my $IsNoModif;
	if ($self->QueryPath eq ''){$IsNoModif=1;}
	
	# Check for trailing ; on the command
	my $InputLine=$self->GetInputLine;
	if ($InputLine=~s/\;$//g){
	    if ($IsNoModif){
		$Thing->SetFlag('FLAG' => 'SHOWRESULT','FLAGMODE' => 'LINE', 'NEW' => 1,%Selection);
	    }; # kill all trailing ; and turn on result
	};
	
	# Check for trailing $ on the command
	if ($InputLine=~s/\$$//g){
	    if ($IsNoModif){
		$Thing->SetFlag('FLAG' => 'SHOWRESULT','FLAGMODE' => 'LINE', 'NEW' => 0,%Selection);
	    }; # kill all trailing $ and turn off result
	};
	
	if ($InputLine ne ''){ 
	    # Input line is for example empty, when input field is disabled
	    # (It will still react to the RETURN key)	    
	    my $Lispobject=MaximaController::Maxima_ASCII_to_LISP('ASCII' => $InputLine); 
	    # if the user enters something invalid, $Lispobject is not valid
	    if ($Lispobject){
		$Thing->SetLispObject
		    ( %Selection,
		      'OLD' => $self->QueryLispSelection,
		      'NEW' => $Lispobject);
		my $Type=$self->QueryEditmode;
		if ($Type eq 'COMMAND' || $Type eq 'MODIF'){
		    $Thing->SetFlag
			(FLAG => 'RECALLNOEVAL',
			 FLAGMODE => 'LINE',
			 NEW => 0,%Selection); # Command modified - normal eval mode
		} elsif ($Type eq 'RESULT'){
		    $Thing->SetFlag
			(FLAG => 'RECALLNOEVAL',
			 FLAGMODE => 'LINE',
			 NEW => 1,%Selection); # Result modified - do not eval
		    # setting the result clears the dirty flag.
		    # Set it.
		    $Thing->SetDirty('EVAL');
		} else {die;}
		
		$Thing->SetDirty('REDRAW');
		$self->Redraw('ALL' => 1);
		$self->PutThingIntoEditor;
	    };
	}; # if input line not empty
    }; # if Thing
};
sub ReturnInDocLine_br{
    my $self=shift or die;
    if ($self->{'THINGINEDITOR'}){
	my $CopyOfDoc=$self->{'DOCLINE'};
	$CopyOfDoc=~s/\n/\\n/g; # replace newline with backslash-n (newline: Ctrl-Return) 
	$self->{'THINGINEDITOR'}->SetDoc($CopyOfDoc);   
	$self->{'DOCLINE'}=~s/\\n/\n/g; # replace backslash-n with 'real' newline-character
	$self->Redraw('ALL' => 1);
    };
};
sub Eval_br{
    my $self=shift or die;
    my $Starttime=time;
    &MaximaController::Evaluate;
    my $Endtime=time;
    $self->Redraw('ALL' => 1);
    # Set last evaluation time in title bar
    $self->SetTitle(EVALTIME => ($Endtime-$Starttime));
};  
sub Save_br{
    my $self=shift or die;
    my %P=@_;
    if ($::Filename eq $::DefaultFilename){$P{'SAVEAS'}=1;};
    
    # Append .mth to the global filename.
    if ($::Filename !~/\.mth$/){$::Filename.='.mth';};

    my $OutFilename;
    if ($P{'SAVEAS'}){
	$OutFilename=$::MainWin->getSaveFile(-defaultextension => '.mth',-title => 'Save to file',-filetypes => \@::Filetypes,-initialdir => $::WorkDir);
    } elsif ($P{'SAVE'}){
	if ($::Filename ne 'untitled.mth'){
	    
	    if ($::Filename=~/^\//){
	    # Filename starts with slash? Then use it as it is.
		$OutFilename=$::Filename;
	    } else {
		# Append the working directory
		$OutFilename="$::WorkDir/$::Filename";
	    };
	};
    } else {die;};
    if ($OutFilename){
	$::ThingManager->Save('FILENAME' => $OutFilename);
    };
};
sub Load_br{
    my $self=shift or die;
    my %P=@_;
    my $InitialDir=$P{INITIALDIR}; die unless defined $InitialDir;
    if ($::MainDirty){
	return if (&YesOrNo('TITLE' => 'Current file was modified','TEXT'=> 'Discard changes and load?') ne 'YES'); 
    };
    my $InFilename=$::MainWin->getOpenFile(-defaultextension => '.mth',-title => 'Choose existing file',-filetypes => \@::Filetypes,-initialdir => $InitialDir);
#,-initialdir => $DefaultPath);
    if (defined($InFilename)){

	# Delete everything from the screen
	$::GlobalCanvas->delete($::GlobalCanvas->find('all'));
	$::ThingManager->Load('FILENAME'=>$InFilename);
	$self->{'DISPLAYPAGE'}='NORMAL';
	$self->RecalcCanvas;
    };
};
sub PutThingIntoEditor{
#    print "UI-PutThingIntoEditor\n";
    my $self=shift or die;
    my %P=@_;
    my $Thing=$P{'THING'};
    delete $self->{'EDITOR_TYPE'};
    delete $self->{'EDITOR_INDEX'};
    delete $self->{'EDITOR_PATH'};
    delete $self->{'THINGINEDITOR'};
    delete $self->{'LISPSELECTION'};
	
    delete $self->{'THINGWIDTH'};
    delete $self->{'THINGUPPERHEIGHT'};
    delete $self->{'THINGLOWERHEIGHT'};
    delete $self->{'XOFFSET'};
    delete $self->{'YOFFSET'};

    $self->ClearInputLine;
    
    $self->{'DOCLINE'}='';
    $::INPARTPath='';
    $::GlobalCanvas->delete('PRECISESELECTIONCURSOR'); # won't hurt	
    $self->{'INPUTLINEWIDGET'}->configure(-state => 'disabled');
    $self->{'DOCLINEWIDGET'}->configure(-state => 'disabled');

    if ($Thing){
	if ($P{'SELECTUPPERLEVEL'}){
	    # This call comes not from a mouse click.
	    # So we create the missing arguments, so that they
	    # point to the topmost command.

	    $P{'UPPERLEVELLISPOBJECT'}=$Thing->QueryLispToplevelCommand or die;
	    $P{'LISPSELECTION'}=$Thing->QueryLispToplevelCommand or die;
	    $P{'PATH'}='';
	    $P{'INDEX'}=0;
	    $P{'TYPE'}='COMMAND';
	};

	$self->{'THINGINEDITOR'}=$Thing or die; 
	$self->{'EDITOR_TYPE'}=$P{'TYPE'}; die unless defined $P{'TYPE'};
	$self->{'EDITOR_INDEX'}=$P{'INDEX'}; die unless defined $P{'INDEX'} || $P{'TYPE'} eq 'HEAD';
	$self->{'EDITOR_PATH'}=$P{'PATH'}; die unless defined $P{'PATH'} || $P{'TYPE'} eq 'HEAD';
	$self->{'DOCLINEWIDGET'}->configure(-state => 'normal');
	
	if ($P{'TYPE'} ne 'HEAD'){
	    $self->{'LISPSELECTION'}=$P{'LISPSELECTION'};
	    if ($self->QueryLispSelection){	
		$self->{'INPUTLINEWIDGET'}->configure(-state => 'normal');
		my $ASCIIString=MaximaController::Maxima_LispToASCII('LISPOBJECT'=>$self->QueryLispSelection);
		$self->{'INPUTLINEWIDGET'}->insert('0.0',$ASCIIString);
		$self->{'INPUTLINEWIDGET'}->tagAdd('sel','0.0','end');
	    };
	    my $StartLispObject=$P{'UPPERLEVELLISPOBJECT'}; # undefined for HANDLE 
	    if ($StartLispObject){
		# set for display in menu line
		my $INPARTPath=$StartLispObject->QueryINPARTPathToLispObject('LISPOBJECT' => $self->QueryLispSelection); 
		# die unless defined $INPARTPath;
		if ($INPARTPath){
		    $self->{'EDITOR_INPARTPATH'}=join(",",@{$INPARTPath});
		    $::INPARTPath='INPART:'.$self->QueryINPARTPath;
		};
	    };
	};
		
	$self->{'DOCLINE'}=$Thing->QueryDoc;
	$self->{'DOCLINE'}=~s/\\n/\n/g; # replace backslash-n with newline-character    
	
	my $GOGeom;
	my $GODrawGeom;

	# We retrieve the dimensions for the box that appears, when a thing is moved.
	# Usually, this is the full graphobject.
	# In case of a modifier this is just the modifier command itself.
	# If the object was just created, we do nothing at all.
	if ($P{'FULLGOGEOM'}){
	    if ($P{'TYPE'} eq 'COMMAND' || $P{'TYPE'} eq 'RESULT'|| $P{'TYPE'} eq 'HEAD' || $P{'TYPE'} eq 'HANDLE'){
		$GODrawGeom=$P{'FULLGODRAWGEOM'} or die join(",",%P);
		$GOGeom=$P{'FULLGOGEOM'} or die;
	    } elsif ($P{'TYPE'} eq 'MODIF'){
		$GODrawGeom=$P{'GODRAWGEOM'} or die;  
		$GOGeom=$P{'GOGEOM'} or die;
	    } else {die;}
	    
	    $self->{'THINGWIDTH'}=GO::Width($GOGeom);
	    $self->{'THINGUPPERHEIGHT'}=GO::UpperHeight($GOGeom);
	    $self->{'THINGLOWERHEIGHT'}=GO::LowerHeight($GOGeom);
	    $self->{'XOFFSET'}=$GODrawGeom->{'XMIN'}-$P{'X'};
	    $self->{'YOFFSET'}=$GODrawGeom->{'YMIN'}+$self->{'THINGUPPERHEIGHT'}-$P{'Y'};
	};  
    }; # If thing  
    $::PopupManager->SetContext(WHAT => 'THING_GLOBAL',
				THING => $self->QueryThing,
				INDEX => $self->QueryIndex,
				PATH => $self->QueryPath,
				EDITMODE => $self->QueryEditmode);
    $self->Redraw('ALL'=>1); # recreate arrows
    $self->DrawCursor;
    if ($P{'TYPE'}){
	if ($P{'TYPE'} eq 'HEAD'){
	    $self->{'DOCLINEWIDGET'}->focus;
	} else {
	    $self->{'INPUTLINEWIDGET'}->focus;
	};
    };	
};
sub YesOrNo{
    my %P=@_ or die;
    my $TopLevelWindow=$P{'WINDOW'};
    if (!$TopLevelWindow){$TopLevelWindow=$::MainWin;}
    
    if (Exists($::Dialog)){$::Dialog->destroy;}; # if everything has gone to hell
    $::Dialog=$::MainWin->Toplevel;   
    
    my $ReturnValue='';

    # Prevent the new window to lose the focus
    $::Dialog->transient($TopLevelWindow);
    my $MessTitle=$P{'TITLE'} or die; $::Dialog->title($MessTitle);
    my $Text=$P{'TEXT'} or die;
    $::Dialog->protocol('WM_DELETE_WINDOW' => sub {$ReturnValue='NO';}); # catch window close command
    $::Dialog->Label(-textvariable => \$Text)->pack(-side => 'top',-fill => 'both',-expand => 1);
    $::Dialog->Button(-text=>'Yes',-width => 16,-command => sub {$ReturnValue='YES';})->pack(-side => 'left',-expand=>'x',-fill=>'x'); 
    $::Dialog->Button(-text=>'No',-width => 16,-command => sub {$ReturnValue='NO';})->pack(-side => 'right',-expand=>'x',-fill=>'x');
    # set local focus to block the main application while this window is around
    eval{$::Dialog->grab;}; # This can fail, if you click too quickly. But it must not die here.
    $::Dialog->resizable(0,0); # prevent resizing
    $::MainWin->waitVariable(\$ReturnValue);
    $::Dialog->grabRelease;
    $::Dialog->destroy;
    return $ReturnValue;
};
sub SetTitle{
    my $self=shift or die;
    my %P=@_;
    my $Evaltime=$P{EVALTIME};
    my $NewTitle="Symaxx/2 $::Revision ".$::Filename;
    if ($Evaltime){$NewTitle.=" t=$Evaltime s";};
    $::MainWin->title($NewTitle);
};
sub Delete_br{
    my $self=shift or die;
    my $ThingInEditor=$self->{'THINGINEDITOR'};
    
    # Delete modifier
    my $EM=$self->QueryEditmode;
    if ($EM eq 'MODIF'){
	my $Path=$self->QueryPath; return unless defined $Path;
	die if $Path eq ''; # then it is not a modifier, but a command!
	my $Index=$self->QueryIndex; return unless defined $Index;

	delete $ThingInEditor->{'COMMANDS'}->[$Index]->{$Path};
	$ThingInEditor->SetDirty('EVAL','REDRAW');
    } elsif ($EM eq 'HEAD'){
	# delete whole thing
	if ($ThingInEditor){
	    $::ThingManager->Delete('THING' => $ThingInEditor);
	};
    } elsif ($EM eq 'COMMAND' || $EM eq 'RESULT'|| $EM eq 'HANDLE'){
	$ThingInEditor->DeleteCommand('INDEX' => $self->{'EDITOR_INDEX'});
    };  
    $self->PutThingIntoEditor();
    $::ThingManager->MakeEvaldirtyIfNeeded;
    $self->Redraw('ALL' => 1);
    $self->RecalcCanvas;
};
sub RecalcCanvas{	
    my @Region=$::GlobalCanvas->bbox('all'); 
    if ($#Region !=3){@Region=(0,0,0,0);} # undefined => (0,0,0,0)
    $::GlobalCanvas->configure(-scrollregion=>[
				       $Region[0]-$::GlobalCanvas->width*3/4,
				       $Region[1]-$::GlobalCanvas->height*3/4,
				       $Region[2]+$::GlobalCanvas->width*3/4,
				       $Region[3]+$::GlobalCanvas->height*3/4]);
};
sub FontTest{
	my $Y=0;
    my $Count; for ($Count=8;$Count<70; $Count++){
	$::GlobalCanvas->fontCreate($Count,-family => 'times',-size => -$Count);
	my $Text="$Count ()[]|";
	$::GlobalCanvas->createText(0,$Y,-text =>$Text,-anchor =>'w',-font => $Count);
	$Y+=$Count;
    };
};
sub Inspect_br{
    &Error('TITLE' => "Log of last Maxima-session",'TEXT' => $::MaximaLog." "); # append a space to avoid error with empty log
};  
sub SetErrorflag{
    my $self=shift or die; 
    my $Flag=shift;
    if ($Flag){$self->{'INSPECTBUTTON'}->configure(-background =>'orange');} else {
	$self->{'INSPECTBUTTON'}->configure(-background =>$self->{'BUTTONORIGCOLOR'});};
};
sub Quit_br{
    if ($::MainDirty){
	return if (&YesOrNo('TITLE' => 'Current file was modified','TEXT'=> 'Discard changes and quit?') ne 'YES'); 
    };
    if ($::TempDirDeleteAutomaticallyAtFinish){
	system("rm -Rf $::TempDir");
    };
    exit;
};
sub InterfacePage_br{
    my $self=shift or die; 
    if ($self->{'DISPLAYPAGE'} eq 'NORMAL'){
	$self->{'DISPLAYPAGE'}='INTERFACE';
	$self->{'DISPBUTTON'}->configure(-background =>'green');
	
	# Avoid confusion, when an invisible thing is in the editor
	if ($self->{THINGINEDITOR} && !$self->{THINGINEDITOR}->QueryFlag(FLAGMODE => 'THING',FLAG => 'INTERFACE')){
	    $self->PutThingIntoEditor; 	
	};
    } else {
	$self->{'DISPLAYPAGE'}='NORMAL';
	$self->{'DISPBUTTON'}->configure(-background =>$self->{'BUTTONORIGCOLOR'});
    };
    $self->Redraw('ALL'=>1,'FORCE' => 1);
};

sub About_br{
    my $MaxData='';
    open MaxHandle,"echo 'quit();' | $::Maxima |";
    my $NewLine;
    while (defined($NewLine=<MaxHandle>)){$MaxData.=$NewLine;};
    close MaxHandle;
    if ($MaxData eq ''){$MaxData="***WARNING***\nMaxima was not found on your system.\nIt has to be available through the command 'maxima'.\nThe Symaxx homepage contains help on installing it.";};

    my $Text="Symaxx/2 $::Revision 2000-2001 Markus Nentwig nentwig\@users.sourceforge.net\n\n
I provide this program on an 'as is' basis without warranty of any kind, either expressed or implied, including, but not limited to, the implied warranties of merchantability and fitness for a particular purpose.
License: 'artistic license' (same as perl) or GPL, whatever is less restrictive
\n

'Short Manual / Symaxx in a nutshell:'
=======
Note: refer to the standard manual, which comes as a .pdf file. Also check the Maxima manual.

=> Use the middle mouse button to place a new object.
=> The upper line is the command, put 'Integrate(x*sin(x),x)' there (replacing 1).
=> Press EVAL to evaluate that. 
=> -x*cos(x)+sin(x) is the result. Usually, you DON'T want to edit it.
=> If you click on 'ID:x', the whole command is selected.

Refer to the object with the ID 42 by writing REF[42] (capital letters, there must be a number in the brackets, variable doesn't work).
=> Create a new object, put there 'diff(REF[42],x)'
=> Replace '42' with the ID of your INTEGRATE command 
=> Press EVAL.
=> x*sin(x) is the output.

Now do
Expand((x+y)^300)
Calculate by hand and compare ;-)

Click on an object with the right mouse key to set some properties.
EVAL does an ev(...,eval),
NUMER does an ev(...,numer) on the command.

If you turn on 'Function/variable definition', then your expression is run through Maxima before you do anything else. DO NOT use references in this case, otherwise you ask for trouble... 

Example:  
=> Para(x,y):=(a*b)/(a+b)
Use in another expression with Para(3,4)
Other example: Pi:%Pi
Make this a Fun/Var definition, and you can write Pi instead of %Pi, if that is more convenient.

If you change the result by hand, your result will not be evaluated for as long, as the 'DO NOT evaluate'-flag is on. If you change the command, this switch turns off by itself.

In the line 'REFS in eval', you can give references for evaluation. Put '42,43' there, and evaluation will do 'eval(....,REF[42],REF[43])'.
Also, you could live without this feature.

Often, you will have a huge calculation, and want to change repeatedly some input values and see, what the output does.
In this case, turn on the flag 'Also show on interface page'. When you now click on the DISP button, all unmarked objects disappear (you can reorder things on the interface page, the location in the original calculation remains unchanged).

The 'Inspect' button gives more detailed error messages.

Comments, bug reports are welcome! 
Contact:
nentwig\@users.sourceforge.net

***Debug information***\nPerl Version $]\nTk Version $Tk::VERSION\n***Maxima prompt***\n".$MaxData."\n";
    
# open the dialog
    if (Exists($::Dialog)){$::Dialog->destroy;}; # if everything has gone to hell
    $::Dialog=$::MainWin->Toplevel;   
    $::Dialog->title('About');
    my $Textfield = $::Dialog->Scrolled('Text', -width => 70, -wrap => 'word', -scrollbars => 'e')->pack(-fill => 'both',-expand=>1);
    $Textfield->delete('0.0','end');
    $Textfield->insert('end',$Text);
    my $Frame=$::Dialog->Frame()->pack(-side => 'bottom', -fill => 'both');
    $Frame->Button(-text=>'OK',-command => sub {$::Dialog->destroy;})->pack(-side => 'left',-expand=>'x',-fill=>'x');  
    $::Dialog->transient($::MainWin); 
    # Grab as last statement!
    $::Dialog->grab;
};  
sub QueryInterfacePage{
    my $self=shift or die; 
    if ($self->{'DISPLAYPAGE'} eq 'NORMAL'){return 0;};
    return 1;
};
sub GetPicture{ 
    my $self=shift or die;
    my %P=@_;
    my $Handle=$P{HANDLE};
    die unless defined $Handle;
    
    my $EPS=$P{EPSFILE}; 

    if (!$EPS){
	# no EPS-file given. But we need it
	# Try to look it up from memory - is there already a file with the handle?
	if ($self->{PICLIST}->{$Handle}->{EPSFILE}){
	    $EPS=$self->{PICLIST}->{$Handle}->{EPSFILE};
	} else {
	    die "Panic: Picture not found";
	};
    };
    my $EPSFullPath=$EPS;
    if ($EPS!~/^\//){ # doesn't start with slash? no absolute path?
	$EPSFullPath="$::WorkDir/$EPS";
    };

    my $Scale=1; 
    if ($P{SCALE}){$Scale=$P{SCALE};};
    # At this point we have an absolute path name. 
    # Now we split it into path and file. 
    # This is needed, because the filename could be pictures/mypic.eps

    my $EPSFilename=MySubs::SplitAbsolutePath($EPSFullPath)->{'FILE'} or die;

    # Try to retrieve it from memory, if the EPS file has not changed
    # This string will change, if the file is modified.
    my $EPSStats=join(':',stat($EPSFullPath));
    if ($self->{'PICLIST'}->{$Handle}->{'PICTUREOBJECT'}){
	if ($self->{'PICLIST'}->{$Handle}->{'STATSEPS'} eq $EPSStats){
	    return $self->{'PICLIST'}->{$Handle}->{'PICTUREOBJECT'};
	};
    };
    # reading the EPS file can fail.
    my $EPSGeom=MySubs::QueryEPSGeom($EPSFullPath);
    if (!$EPSGeom){
	print "Failed to read $EPSFullPath.\n";
	return undef;
    };
    my $XSize=$EPSGeom->{'X2'}-$EPSGeom->{'X1'} or die;
    my $XSizeString='';
    $XSize*=$Scale; 
    $XSize=int($XSize); # pstopnm needs integer
    $XSizeString="-xsize $XSize ";
    my $a=$EPSFilename; $a=~s/\.eps$//i;
    my $FinalPPMFilename="$::TempDir/$a.ppm";
    unlink $FinalPPMFilename; # if it's not there, that doesn't mean anything
    my $Cmd="$::CodeDir/Symaxx2/pstopnm_modif -portrait -ppm -xborder 0 -yborder 0 $XSizeString -outfile $FinalPPMFilename $EPSFullPath > /dev/null 2> /dev/null";
#    print "Running $Cmd\n";
    # This creates now FinalPPMFilename
    system($Cmd); 
    if (!(-e $FinalPPMFilename)){
	print "\n\n***Image conversion failed. Probably file not found***\n";
	return undef;
    };
    die unless -e $FinalPPMFilename;
    $self->{'PICLIST'}->{$Handle}->{'PICTUREOBJECT'}=$::GlobalCanvas->Photo($Handle, -format => 'PPM',-file => $FinalPPMFilename) or die;
    $self->{'PICLIST'}->{$Handle}->{'STATSEPS'}=$EPSStats; 
    $self->{'PICLIST'}->{$Handle}->{'EPSFILE'}=$EPSFullPath;
#    print "UIM - GetPicture -> Success!\n";
    return $self->{'PICLIST'}->{$Handle}->{'PICTUREOBJECT'};
};
sub DeletePicture{
    die 'obsolete';
    my $self=shift or die;
    my %P=@_;

    my $ID=$P{'ID'}; die unless defined $ID;
    my $Identifier=$P{'IDENTIFIER'} or die;
    my $Handle=$Identifier.$ID;
    delete $self->{'PICLIST'}->{$Handle};
};
sub Print_br{  
    my $self=shift or die;
    my %P=@_;
    my $Mode=$P{'MODE'} or die;
    my $Width=$::PaperwidthInDots;my $Height=$::PaperheightInDots;my $Rotation=0;
    if ($Mode eq 'LANDSCAPE'){
	# exchange width and height if landscape
	$Width=$::PaperheightInDots;my $Width=$::PaperwidthInDots;$Rotation=90;}
    my ($X1,$Y1,$X2,$Y2)=$::GlobalCanvas->bbox('all');
    if (!defined $X1 || $X1==$X2 || $Y1==$Y2){
	&Error('TEXT' => 'The canvas is empty! Refuse to create empty postscript file','TITLE' => 'Nothing to do!'); return;
    };
    my $Outfile="$::WorkDir/output.ps";
    $self->Redraw('ALL'=>1,'FORCE' => 1,'PRINTMODE'=>1); # suppress images
    my $Error=$::GlobalCanvas->postscript
	(-file=>$Outfile,
	     '-x' => $X1,'-y' => $Y1,
	 -width=>($X2-$X1+1),-height=>$Y2-$Y1+1,
	 rotate => $Rotation,
	 -pagewidth=>$Width,
	 -pageheight=>$Height);
    if ($Error){ 
	&Error('TEXT' => "Unable to create postscript output to  $Outfile - internal error.",'TITLE' => 'Printing failed'); return;
    };
    if (!open PostscriptFile,"<$Outfile"){	
	&Error('TEXT' => 'Import of canvas postscript failed - internal error','TITLE' => "unable to open $Outfile for read."); return;
    };
    # substitute the mark by the EPS postscript file
    my $AllPSFile='';
    my $InLine;while (defined($InLine=<PostscriptFile>)){
	$AllPSFile.=$InLine;
    };
#    if ($AllPSFile=~/gsave.*grestore/xs){die;}
    while ($AllPSFile=~/
	   ^
	   (.*)
	   gsave(
		 .*?
		 \(
		 NobodyRightInHisMindWouldUseThisString\_.+\_Yes
		 \)
		 .*?
		 )grestore
	   (.*)
	   $/xs){
	my $Head=$1;
	my $StuffInMiddle=$2;
	my $Tail=$3;
	$StuffInMiddle=~s/\n/ /g;
#	print "Gotcha: $StuffInMiddle\n";
	# Disassemble this:
	# 235 449 [ (SymaxxPictureForID1) ]
	$StuffInMiddle=~/(\-?\d+)\s+(\-?\d+)\s+\[\s*\(NobodyRightInHisMindWouldUseThisString\_(.+)\_Yes\)\s*\]/ or die $StuffInMiddle;
	my $NewX=$1;
	my $NewY=$2;
	my $ReplHandle=$3;
	my $PictureCode=$::UIManager->QueryPicturePostscript('X'=>$NewX,'Y'=>$NewY,'HANDLE' => $ReplHandle) or die;
	$AllPSFile="$Head ".join(" ",@{$PictureCode})." $Tail";
    };
    close PostscriptFile;
    if (!open PSOut,">$Outfile"){ 
	&Error('TEXT' => "Unable to open $Outfile for write.",'TITLE' => "File open failed.");	
    }; 
    print PSOut $AllPSFile;
    close PSOut; 
    $self->Redraw('ALL'=>1,'FORCE' => 1); #redraw images
    # OK-box
    &Error('TEXT' => "A postscript file was generated in $Outfile.",'TITLE' => 'Postscript printing succeeded');	
};

sub Error{
    my %P=@_ or die;
    my $ErrString=$P{'TEXT'}; die unless defined $ErrString;
    my $Height=32;
    if ($P{'HEIGHT'}){$Height=$P{'HEIGHT'};};
    my $ReturnValue;

    if (Exists($::Dialog)){$::Dialog->destroy;}; # if everything has gone to hell
    $::Dialog=$::MainWin->Toplevel;   
    
    # Prevent the new window to lose the focus
    $::Dialog->transient($::MainWin);  
    $::Dialog->bind('<space>',sub{$ReturnValue=1;});
    $::Dialog->bind('<Return>',sub{$ReturnValue=1;});
    $::Dialog->bind('<Escape>',sub{$ReturnValue=1;});    

    my $MessTitle=$P{'TITLE'} or die; $::Dialog->title($MessTitle);
    my $Text=$P{'TEXT'} or die;
    $::Dialog->protocol('WM_DELETE_WINDOW' => sub {$ReturnValue='NO';}); # catch window close command  
    my $Textfield = $::Dialog->Scrolled('Text', -width => 70, -wrap => 'word', -scrollbars => 'e')->pack(-fill => 'both',-expand=>1);
    $Textfield->insert('end',$Text);

    $::Dialog->Button(-text=>'OK',-width => 16,-command => sub {$ReturnValue='OK';})->pack(-side => 'left',-expand=>'x',-fill=>'x'); 
 
    # set local focus to block the main application while this window is around
    eval{$::Dialog->grab;}; # This can fail, if you click too quickly. But it must not die here.
    $::Dialog->resizable(0,0); # prevent resizing
    $::MainWin->waitVariable(\$ReturnValue);
    if(Exists($::Dialog)){
	$::Dialog->grabRelease;
	$::Dialog->withdraw;
	$::Dialog->destroy;
    };
};
sub NewThing_br{
    my $self=shift or die;
    my %P=@_;
    my $X; my $Y;
    my $ASCII=$P{'ASCII'};
    my $Doc=$P{'DOC'};
    if (!defined $ASCII){$ASCII='1';} # default expression
    if (defined $P{'X'} && defined $P{'Y'}){
	$X=$P{'X'};$Y=$P{'Y'};
    } else {
	$X=$self->{'LASTINSERTX'};
	$Y=$self->{'LASTINSERTY'}+$::DefaultYStepInEditor;
    };	
    $self->{'LASTINSERTX'}=$X;
    $self->{'LASTINSERTY'}=$Y;
    my $NewThing=$::ThingManager->AddFromASCII('ASCII'=>$ASCII,'X'=>$X,'Y'=>$Y,'DOC' => $Doc);
    if ($NewThing){
	$self->{LASTINSERTTHING}=$NewThing;
	if ($self->{DISPLAYPAGE} eq 'INTERFACE'){
	    $NewThing->SetFlag(FLAGMODE => 'THING',
			       FLAG => 'INTERFACE',
			       NEW => 1);};
	# generate graphics object
	$self->Redraw('ALL' => 1);
	$self->PutThingIntoEditor('THING' => $NewThing,'SELECTUPPERLEVEL'=>1);	
	$::MainDirty=1;
    };    
};
sub Manual_br{
    my $self=shift or die;
    my $P=shift or die;
    my $File='';
    if ($P eq 'SYMAXXMAN'){
	my $Manual="$::CodeDir/doc/Manual.pdf";
	# run as background job (don't wait for completion)
	if (fork ==0){
	    my $Viewer;
	    my @Viewers=@::PDFViewer;
	    while ($Viewer=shift @Viewers){
		{exec "$Viewer $Manual";};
		print "Failed to start $Viewer.\n";
	    }; # while viewer 
	    die "Error: Failed to start a viewer for .pdf file. ".join(",",@::PDFViewer)." do not work. Please install one of those programs or edit \@::PDFViewer in Preferences.pm.";
	    return;
	};
    } elsif ($P eq 'FORMAT'){
	my $Manual="$::CodeDir/doc/Manual_for_FORMAT_package.pdf";
	# run as background job (don't wait for completion)
	if (fork ==0){
	    my $Viewer;
	    while ($Viewer=shift @::PDFViewer){
		{exec "$Viewer $Manual";};
		print "Failed to start $Viewer.\n";
	    }; # while viewer
	    &Error('TITLE' => "No PDF viewer",'TEXT' => "Error: Failed to start a viewer for .pdf file. ".join(",",@::PDFViewer)." do not work. Please install one of those programs or edit \@::PDFViewer in Preferences.pm.");
	    return;
	};
    } elsif ($P eq 'MAXIMAMAN'){
	$File='maxima_toc.html';
    } elsif ($P eq 'MAXIMAPRIMER'){
	$File='intro.html';
    } elsif ($P eq 'MAXIMAINDEX'){
	$File='maxima_40.html';
    } else {die;}
    if ($File){
	my $AbsFile=`find $::MaximaDocDir -name $File`;

	# Find may produce several lines. Use only one.
	while ($AbsFile=~/^(.*)\n/){$AbsFile=$1;};

	if (!$AbsFile){
	    &Error('TITLE' => "File not found",'TEXT' => "Error: unable to find $File in $::MaximaDocDir. Edit symaxx and change $::MaximaDocDir to the right location (any higher folder will do)"); return;
	};
	# run as background job (don't wait for completion)
	if (fork ==0){
	    my $Viewer;
	    my @Browsers=@::HTMLBrowser;
	    while ($Viewer=shift @Browsers){
		{print $Viewer;
		    exec("$Viewer $AbsFile");};
		print "Failed to start $Viewer.\n";
	    }; # while viewer
	    die "Error: Failed to start a viewer for .html file. ".join(",",@::HTMLBrowser)." do not work. Please install one of those programs or edit \@::HTMLBrowser in Preferences.pm.";
	};
    };   
};
sub QueryPicturePostscript{
    my $self=shift or die; 
    my %P=@_;
    my $TotalPicName=$P{'HANDLE'} or die;
    my $EPS=$self->{'PICLIST'}->{$TotalPicName}->{'EPSFILE'} or die;
    my $X=$P{'X'}; die unless defined $X;
    my $Y=$P{'Y'}; die unless defined $Y;
    
    my $EPSFullPath=$EPS;
    if ($EPS!~/^\//){ # doesn't start with slash? no absolute path?
	$EPSFullPath="$::WorkDir/$EPS";
    };
    
    open EPSFile,"<$EPSFullPath" or die "unable to open EPS-file $EPSFullPath";
    my @EPSData=<EPSFile>;
	
    my %EPSGeom=%{MySubs::QueryEPSGeom($EPSFullPath)} or die;
    my $X1=$EPSGeom{'X1'};my $Y1=$EPSGeom{'Y1'};my $X2=$EPSGeom{'X2'};my $Y2=$EPSGeom{'Y2'};
    
    die "%%BoundingBox not found! $EPSFullPath is no EPS file? " unless defined $Y2; 
    my $Picture=$self->GetPicture(HANDLE => $TotalPicName) or die;
    my $EPSWidth=MySubs::Max($X2-$X1,1);
    my $EPSHeight=MySubs::Max($Y2-$Y1,1);
    my $ScreenWidth=MySubs::Max($Picture->width,1);
    my $ScreenHeight=MySubs::Max($Picture->height,1);
    my $ScaleX=$ScreenWidth/$EPSWidth;
    my $ScaleY=$ScreenHeight/$EPSHeight;
    my $XOffset=-$X1; my $YOffset=-$Y2; 
    # correction factor for position (found by trial-and-error)
    $X-=1;$Y+=1;
    unshift @EPSData,"save gsave $X $Y translate $ScaleX $ScaleY scale $XOffset $YOffset translate\n";
    unshift @EPSData,'/showpage 	% - showpage - 
{ %def 
gsave 
grestore 
} bind def
'; # redefine showpage operator to turn it off
    push @EPSData,"grestore restore\n";
    return \@EPSData;
};
sub InstantSolve_br{
    my $self=shift or die; 
    my $Thing=$self->{THINGINEDITOR};
    if ($Thing){
	my $ID=$Thing->{'ID'}; die unless defined $ID;	
	my $InputLine=$self->GetInputLine;
	if ($InputLine){
	    my $Command="InstantSolve(REF[$ID],$InputLine)";
	    my $X=$self->{'MOUSEX'};my $Y=$self->{'MOUSEY'};
	    $self->NewThing_br('ASCII' => $Command,'X'=> $X,'Y'=>$Y);
	    $self->ClearInputLine;
	};
    };
};
sub New_br{ 
    my $self=shift or die;
    if ($::MainDirty){
	return if (&YesOrNo('TITLE' => 'Current file was modified','TEXT'=> 'Discard changes?') ne 'YES'); 
    };
    $::GlobalCanvas->delete($::GlobalCanvas->find('all'));
    $::Filename=$::DefaultFilename;
    # keep working directory
    $::ThingManager->PurgeRedundantData;
    $::ThingManager=&ThingManager::New;	
    $self->SetTitle;
    $self->Redraw('ALL'=>1);
};
sub CreateFromInput_br{
    my $self=shift or die;
    my %P=@_;
    my $Doc=$P{'DOC'};
    my $InputLine=$self->GetInputLine;
    if ($InputLine){	
	my $X=$self->{'MOUSEX'};my $Y=$self->{'MOUSEY'};
	$self->NewThing_br('ASCII' => $InputLine,'DOC' => $Doc,'X'=>$X,'Y'=>$Y);
    };
};
sub ExtractFromResult_br{
    my $self=shift or die;
    my %P=@_;
    my $InputLine;
    if ($self->{'THINGINEDITOR'} && $self->QueryEditmode eq 'RESULT'){
	my $ID=$self->{'THINGINEDITOR'}->QueryID;
	my $INPARTPath=$self->QueryINPARTPath;
	if (defined $INPARTPath){
	    # Could be empty, then no colon
	    if ($INPARTPath ne ''){$INPARTPath=','.$INPARTPath;}
	    $InputLine="INPART(REF[$ID]$INPARTPath)";
	};
    };
    if ($InputLine){	
	my $X=$self->{'MOUSEX'};my $Y=$self->{'MOUSEY'};
	$self->NewThing_br('ASCII' => $InputLine,'X'=>$X,'Y'=>$Y);
    };
};
sub SelfTest_br{
    my $self=shift or die; 
    my $TestFile=shift or die;
    if ($::MainDirty){
	return if (&YesOrNo('TITLE' => 'Current file was modified','TEXT'=> 'Discard changes?') ne 'YES'); 
    };
    $TestFile="$::MaximaSource/doc/$TestFile";
    $self->{'LASTINSERTX'}=0;
    $self->{'LASTINSERTY'}=0;
    open In,"<$TestFile" or die "Can't open $TestFile.";
    my @Tests=<In>;
    close In;
    my $Nextline;
    my $Start=0;
    while ($#Tests>-1){
	$Nextline=shift @Tests;chop $Nextline;
	if ($Nextline=~/\;$/){
	    chop $Nextline; # remove ;
	    print "XXX $Nextline \n";  
	    $self->ClearInputLine;
	    $self->{'INPUTLINEWIDGET'}->insert('0.0',$Nextline);
	    my $Result=shift @Tests;chop $Result;chop $Result; # remove newline and $ or ;
	    $self->CreateFromInput_br('DOC' => "Correct: $Result");
	    print "    $Result \n";
	    $Start=1;
	} else {if ($Start){return;}}
    }
    $::MainDirty=0;
};
sub GetInputLine{
    my $self=shift or die;
    my $String=$self->{'INPUTLINEWIDGET'}->get('0.0','end');
    chop $String; 
    return $String;
};
sub ClearInputLine{
    my $self=shift or die;
    $self->{'INPUTLINEWIDGET'}->delete('0.0','end');
};
sub ArrangeCanvasLevels{
    # Lower the pictures behind the equations
#    $::GlobalCanvas->lower('PICTURE');
    
    # Lower the background behind the equations
    $::GlobalCanvas->lower('THINGBACKGROUND');
    
    # lower the arrows behind everything else
    $::GlobalCanvas->lower('ARROW');
};
sub Palette_br{	
    $::PopupManager->TogglePalette;
};
sub PaletteChoice{
    my $self=shift or die;
    my $NewCommand=shift; die unless defined $NewCommand;

    # If an expression is selected then 
    #   If a part is selected as ASCII text then
    #      Replace the selection with the new command, using it as arg
    #   Else 
    #      Enter the new command at the cursor
    # Else 
    #   Create a new thing using the command
    
    if ($self->{'THINGINEDITOR'}){
	# put command into ASCII text entry field
	
	# is there a selection?
	my @SelectionIndex=$self->{'INPUTLINEWIDGET'}->tagRanges('sel');
	if ($#SelectionIndex == 1){
	    my $OldSelection=$self->{'INPUTLINEWIDGET'}->get($SelectionIndex[0],$SelectionIndex[1]);
	    $self->{'INPUTLINEWIDGET'}->delete($SelectionIndex[0],$SelectionIndex[1]);
	    $OldSelection=~s/\n$//g; # remove trailing returns
	    $NewCommand=~s/EXPR/$OldSelection/g;
	    $self->{'INPUTLINEWIDGET'}->insert($SelectionIndex[0],$NewCommand);
	} else {
	    $self->{'INPUTLINEWIDGET'}->insert('insert',$NewCommand);
	};
    } else {
	$self->NewThing_br('ASCII' => $NewCommand);
    };
};
sub QueryField{
    my $self=shift or die;
    my $Field=shift or die;
    die 'unknown field' unless ($Field eq 'INPARTPATH' || $Field eq 'EDITMODE' || $Field eq 'INPARTPATHTEXT');
    return $self->{$Field};
};	
sub InsertREFInEntryLine{ 
    my $self=shift or die;
    my @SelectionIndex=$self->{'INPUTLINEWIDGET'}->tagRanges('sel');
    if ($#SelectionIndex == 1){
#	my $OldSelection=$self->{'INPUTLINEWIDGET'}->get($SelectionIndex[0],$SelectionIndex[1]);
	$self->{'INPUTLINEWIDGET'}->delete($SelectionIndex[0],$SelectionIndex[1]);
#	$NewCommand=~s/EXPR/$OldSelection/g;
	$self->{'INPUTLINEWIDGET'}->insert($SelectionIndex[0],'REF[]');
    } else {
	$self->{'INPUTLINEWIDGET'}->insert('insert','REF[]');
    };
    # go back one character
    $self->{'INPUTLINEWIDGET'}->markSet('insert','insert -1 char');
};
sub DrawCursor{
    my $self=shift or die;
    return unless $self->{'THINGINEDITOR'};
    $self->{'THINGINEDITOR'}->HighlightPreciseSelection
	('LISPSELECTION' => $self->QueryLispSelection,
	 'SELECTIONTYPE' => $self->QueryEditmode,
	 'INDEX' => $self->QueryIndex,
	 'PATH' => $self->QueryPath
	 ); # after arrows cursor box
};
sub NewModifier_br{
    my $self=shift or die;
    my $Editmode=$self->QueryEditmode or return; 
#    return unless $Editmode eq 'RESULT' || $Editmode eq 'HEAD';
    
    my $Thing=$self->{'THINGINEDITOR'} or return;
    	
    # The modifier will be applied to the part of the result, which is currently in the editor.
    # The INPART-Path to this subexpression is therefore the path to the new modifier.
    # If the result with the index N is selected, the modifier belongs into command N+1.
    # If this does not exist, we have to create it.
    my $Index;
    my $INPARTPath;
    if ($Editmode eq 'COMMAND'){
	$Index=$self->QueryIndex; return unless defined $Index; # can be 0
	$INPARTPath='';
    } elsif ($Editmode eq 'RESULT' || $Editmode eq 'HANDLE'){
	$Index=$self->QueryIndex; return unless defined $Index; # can be 0
	$INPARTPath=$self->QueryINPARTPath; die unless defined $INPARTPath;
    } elsif ($Editmode eq 'HEAD'){
	# New modifier on head inserts first line
	$Index=-1;$INPARTPath='';
    } else {return;} # command can't be inserted on modifier.
    my $EditorType;
    my @CommandsArray=@{$Thing->{'COMMANDS'}};
    
    my $NewLineDone;
    # New line has to be created, when a new command or modifier is inserted on the last line
    if ($Index==$#CommandsArray){
	my $NewElem={'LISPOBJECT'=>MaximaController::Maxima_ASCII_to_LISP('ASCII' =>'%'),'SHOWCOMMAND_LINE' => 1,'SHOWRESULT_LINE' => 1};  
	push @CommandsArray,{'' => $NewElem};
	$NewLineDone=1;
    };
    
    # New line, but not the last one (which is already done)
    if ($INPARTPath eq '' && !$NewLineDone){
	$EditorType='COMMAND';
	my $NewElem={'LISPOBJECT'=>MaximaController::Maxima_ASCII_to_LISP('ASCII' =>'%'),'SHOWCOMMAND_LINE' => 1,'SHOWRESULT_LINE' => 1};    
	if ($Index >=0){
	    my $OldElem=$Thing->{'COMMANDS'}->[$Index];
	    # Insert anywhere except at beginning of list
	    splice(@CommandsArray,$Index,1,($OldElem,{'' => $NewElem}));
	} else {
	    #insert as first lime
	    unshift @CommandsArray,{'' => $NewElem};
	};
    } elsif ($INPARTPath ne ''){
	$EditorType='MODIF';
	# Create new modifier (new line has already been created, if needed)
	$CommandsArray[$Index+1]->{$INPARTPath}={'DX' => 50,'DY' => 10,'LISPOBJECT'=>MaximaController::Maxima_ASCII_to_LISP('ASCII' =>'%'),'SHOWRESULT' => 1} or die;
    } elsif ($INPARTPath eq '' && $NewLineDone){
	$EditorType='COMMAND';
    };
    $Thing->{'COMMANDS'}=\ @CommandsArray;
    
    $Thing->SetDirty('EVAL','REDRAW');
    $self->Redraw('ALL' => 1);
    # We can only put it into the editor, if it has been drawn already.
    if ($EditorType){
	my $Lispobject=$CommandsArray[$Index+1]->{$INPARTPath}->{'LISPOBJECT'} or die;
	my $UpperLevelLispobject=$Lispobject;
	
	# We're not taking any shortcuts here...
	$self->PutThingIntoEditor
	    ('THING' => $Thing,
	     'PATH' => $INPARTPath,
	     'TYPE' => $EditorType,
	     'INDEX' => $Index+1,
	     'LISPSELECTION' => $Lispobject,
	     'UPPERLEVELLISPOBJECT' => $UpperLevelLispobject);	
    };
};	

# A very important difference:

# QueryPath gives the path of the current modifier.
# The modifier replaces the position in the last result specified
# by Path.

# QueryINPARTPath gives the path to the subexpression within
# the 'active' expression.

# For example: The last result was 
# a+b+c
# The next command has a modifier applied on its c,
# The modifier is %+1
# The user clicks on the 1
# Then Path is 3, because c is the third element in expr.
# But INPARTPath will be 2, because 1 is the second element
# in %+1.
# INPARTPath is seldom used, because usually the selection is
# specified by naming the reference to the old LISP object, which
# will then be tracked down and replaced.

sub QueryPath{return shift->{'EDITOR_PATH'};};
sub QueryINPARTPath{
    my $self=shift; my $p=$self->{'EDITOR_INPARTPATH'};
    if ($p){
	die $p if(ref($p) eq 'ARRAY');
    };
    return $p;
};

sub QueryEditmode{return shift->{'EDITOR_TYPE'};};
sub QueryIndex{return shift->{'EDITOR_INDEX'};};
sub QueryThing{return shift->{'THINGINEDITOR'};};
sub QueryLispSelection{return shift->{'LISPSELECTION'};};
sub Redraw{
    my $self=shift or die;
    my %P=@_;
    $::ThingManager->Redraw(%P);
    $self->DrawCursor;
};
sub QueryFeature{
    my $self=shift or die;
    my %P=@_;
    my $Feature=$P{FEATURE} or die;
    if ($Feature eq 'UNITS'){
	return $::MaximaUseUnits;
    } elsif ($Feature eq 'SELECTION'){
	return $::MaximaUseSelection;
    } elsif ($Feature eq 'GNUPLOT'){
	return $::MaximaUseGnuplot;
    } elsif ($Feature eq 'FORMAT'){
	return $::MaximaUseFormat;
    } elsif ($Feature eq 'NUMERICAL'){
	return $::MaximaUseNumerical;
    } else {die;};
};
1;
# __END__
